/*                    Lex Program #3
               To check the validity of a C file                      */

%{
#define MAX 100
char stack[MAX];
int top=-1,valid=0;
%}
%x    MAIN
%option noyywrap
%%
"main()"          {valid=1;BEGIN(MAIN);}
<MAIN>[\{\(\[]    stack[++top]=*yytext;
<MAIN>\]          if(stack[top--]!='[')valid=0;
<MAIN>\}          if(stack[top--]!='{')valid=0;
<MAIN>\)          if(stack[top--]!='(')valid=0;
<*>.|[\t\n]+      ;
%%
main()
{
char infile[256];
printf("Enter the input file name : ");
scanf("%s",infile);
yyin=fopen(infile,"r");
yylex();
if(valid&&top==-1)
printf("\nValid File");
else
printf("\nInvalid File");
}

/**** 	OUTPUT****************************************************************
Enter the input file name :
example.c
Valid File
example.c file contains any  valid C program                             ****/ 

