/*   Lex Program #4
To count the number of alphabets, blankspaces, words and lines in the given text */

%{
int chars=0,words=0,blanks=0,lines=0;
%}
%option noyywrap
%%
[\n]                 lines++,chars++,words++;
[ ]/[a-zA-Z0-9]      blanks++,chars++,words++;
[ ]                  blanks++,chars++;
[\t]/[a-zA-Z0-9]     words++,chars++;
.                    chars++;
%%
main()
{
printf("Enter the text to be scanned : ");
yylex();
printf("Number of characters  %d\nNumber of words  %d\nNumber of blanks  %d\nNumber of lines  %d\n",chars,words,blanks,lines);
}  

/***************************************************************************
OUTPUT
Enter the text to be scanned : All the BEST
Number of characters  13
Number of words  3
Number of blanks  2
Number of lines  1
*/
