/*     Lex Program #6
To count the number of +,-,*,/,digits & operators in an arithmetic expression */

%{
int p_count=0,mi_count=0,mul_count=0,div_count=0,digit_count=0,valid=1,top=-1,t=-1;
char stack[50],st[50];
%}
%option noyywrap
%%
[a-zA-Z0-9]+     digit_count++;
\+               {p_count++;st[++t]='+';}  
\-               {mi_count++;st[++t]='-';}
\*               {mul_count++;st[++t]='*';}
\/               {div_count++;st[++t]='/';}
[\{\[\(]         stack[++top]=*yytext;
\)               if(stack[top--]!='(')valid=0;
\]               if(stack[top--]!='[')valid=0;
\}               if(stack[top--]!='{')valid=0;
.|[\t\n]+ ;
%%
main()
{
int i,total;
printf("Enter an Arithmetic Expression : ");
yylex();
if(valid&&top==-1)
{
printf("Valid Arithmetic Expression\n");
total=p_count+mi_count+mul_count+div_count;
printf("Number of additions  %d\n",p_count);
printf("Number of subtractions  %d\n",mi_count);
printf("Number of multiplications  %d\n",mul_count);
printf("Number of divisions  %d\n",div_count);
printf("Number of digits  %d\n",digit_count);
printf("Total number of operators  %d\n",total);
printf("\nThe operators are\n");
for(i=0;i<=t;i++)
printf("%c ",st[i]);
}
else
printf("Invalid Arithmetic Expression\n");
}

/************************************************************************
 OUTPUT
Enter an Arithmetic Expression :  8+(5*8)-5
Valid Arithmetic Expression
Number of additions  1
Number of subtractions  1
Number of multiplications  1
Number of divisions  0
Number of digits  4
Total number of operators  3

The operators are
+ * -
*/
