/*                  Lex Program #7
       To count the number of variables declared in a C file                    */

%{
int ident_count=0;
%}
%option noyywrap

IDENTIFIER [a-zA-Z_][a-zA-Z0-9_]*
DECLN "int"|"float"|"char"|"long"
%x DEFN

%%

{DECLN} BEGIN(DEFN);
<DEFN>{IDENTIFIER}\,    ident_count++;
<DEFN>{IDENTIFIER}\;    {ident_count++,BEGIN(INITIAL);}
<*>.|\n+;

%%
main()
{
char infile[256];
printf("Enter the input filename : ");
scanf("%s",infile);
yyin=fopen(infile,"r");
yylex();
printf("Number of Identifiers in the input file are : %d\n",ident_count);
}
