/*    Yacc Program #3
Yacc part to count the levels of nesting of IF statements                    */

%{
int depth=0,nest_count=0;
%}
%token IF  COND  STAT
%%
start :stat
      | start stat
      ;
stat : IF '(' COND ')' '{'
        {if(nest_count<(++depth)) nest_count=depth;}
      | STAT
      | '}'
        {--depth;}
      ;
%%
main()
{
printf("Enter the text to be passed\n");
if(!yyparse())
printf("Number of levels of nesting : %d\n",nest_count);
}
yyerror()
{
printf("Parse Error\n");
exit(-1);
}

/*************************************************************************
 OUTPUT
Enter the text to be passed 
IF(8>5){
  IF(5<8){
    "DO WELL";}
 "ALL THE BEST";}        
Number of levels of nesting : 2
*/
