/*    Yacc Program #4
To count whether a given  variable is valid or not                       */

%token LETTER DIGIT LOWER
%%
variable : LOWER DIGIT other
         | LOWER DIGIT
         ;
other : other LETTER
      | other DIGIT
      | other LOWER
      | LETTER
      | DIGIT
      | LOWER
      ;
%%
 yylex()
{
int c;
c=getchar();
if(isalpha(c)&&islower(c))
return(LOWER);
else if(isalpha(c))
return(LETTER);
else if(isdigit(c))
return(DIGIT);
else if(c=='\n')
return(0);
else
return(c);
}
yyerror()
{
printf("Invalid Variable\n");
}
int main()
{
printf("Enter any C variable : ");
if(!yyparse())
printf("Valid Variable\n");
} 

/***********************************************************************

 OUTPUT
Enter any  variable : d5
Valid Variable  
Enter any variable : a
Invalid Variable


*/
