/*                      Lex Program #1
To count the number of vowels and consonants in the given statement          */

%{
int vcount=0,ccount=0;
%}
%option noyywrap
vowel      a|e|i|o|u|A|E|I|O|U;
%%
[\t\n]+            ;
{vowel}           vcount++;
[a-zA-Z]          ccount++;
.                         ;
%%
main()
{
printf("Enter the text to be scanned : "); 
yylex();
printf("Number of Vowels %d\nNumber of Consonants %d\n",vcount,ccount);
} 

/*****************************************************************************

     Output
Enter the test to be scanned : All the BEST
Number of Vowels 3
Number of Consonants 7
*/
