/*   Yacc Program #3
Lex part to count the levels of nesting of IF statements                 */

%{
#include "y.tab.h"
%}
%option noyywrap
CHAR   [a-zA-Z<>=!]
%x CONDSTART
%%
IF                      return IF;
\(                      {BEGIN(CONDSTART);return '(';}
<CONDSTART>\)           {BEGIN(INITIAL);return ')';}
<CONDSTART>{CHAR}+      return COND;
[\{\}]                  return(*yytext);
{CHAR}*                 return STAT;
<*>.|[ \t\n]+   ;
%%
