/*    Yacc Program #8
Lex part to check the validity of "IF THEN ELSE" construct                  */

%{
#include "y.tab.h"
%}
%option noyywrap
CHAR [a-zA-Z<>=!]
%x    CONDSTART
%%
IF                   return IF;        
ELSE                 return ELSE;
THEN                 return THEN;
\(                   {BEGIN(CONDSTART);return '(';}
<CONDSTART>\)        {BEGIN(INITIAL);return ')';}
<CONDSTART>{CHAR}+   return COND;
[\{\}]               return(*yytext);
{CHAR}*              return STAT;
<*>.|[ \t\n]+   ;
%%